<template>
  <a-card
    title='设备启封'
    :bordered="false"
  >
    <!-- 查询区域 -->
    <div class="table-page-search-wrapper">
      <a-form
        layout="inline"
        @keyup.enter.native="searchQuery"
      >
        <a-row :gutter="24">
          <!-- <a-col :xl="6" :lg="7" :md="8" :sm="24" v-if="false">
            <a-form-item label="变动方式(封存-seal，启封-unseal,报废-scrap，处置-disposal)">
              <a-input placeholder="请输入变动方式(封存-seal，启封-unseal,报废-scrap，处置-disposal)"
                :defaultValue="changeMethod"></a-input>
            </a-form-item>
          </a-col> -->
          <a-col
            :xl="6"
            :lg="7"
            :md="8"
            :sm="24"
          >
            <a-form-item label="单据号">
              <a-input
                placeholder="请输入单据号"
                v-model="queryParam.num"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col
            :xl="6"
            :lg="7"
            :md="8"
            :sm="24"
          >
            <a-form-item label="审批状态">
              <j-dict-select-tag
                placeholder="请选择审批状态"
                v-model="queryParam.auditStatus"
                dictCode="audit_status"
              />
            </a-form-item>
          </a-col>
          <!-- <template v-if="toggleSearchStatus">

            <a-col :xl="10" :lg="11" :md="12" :sm="24">
              <a-form-item label="创建时间">
                <j-date placeholder="请选择开始日期" class="query-group-cust" v-model="queryParam.createTime_begin"></j-date>
                <span class="query-group-split-cust"></span>
                <j-date placeholder="请选择结束日期" class="query-group-cust" v-model="queryParam.createTime_end"></j-date>
              </a-form-item>
            </a-col>
          </template> -->
          <a-col
            :xl="6"
            :lg="7"
            :md="8"
            :sm="24"
          >
            <span
              style="float: left;overflow: hidden;"
              class="table-page-search-submitButtons"
            >
              <a-button
                type="primary"
                @click="searchQuery"
                icon="search"
              >查询</a-button>
              <a-button
                type="primary"
                @click="searchReset"
                icon="reload"
                style="margin-left: 8px"
              >重置</a-button>
              <!-- <a @click="handleToggleSearch" style="margin-left: 8px">
                {{ toggleSearchStatus ? '收起' : '展开' }}
                <a-icon :type="toggleSearchStatus ? 'up' : 'down'" />
              </a> -->
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!-- 查询区域-END -->

    <!-- 操作按钮区域 -->
    <div class="table-operator">
      <a-button
        @click="handleAdd"
        type="primary"
        icon="plus"
      >新增</a-button>
    </div>

    <div>
      <a-table
        ref="table"
        size="middle"
        bordered
        rowKey="id"
        class="j-table-force-nowrap"
        :scroll="{ x: true }"
        :columns="columns"
        :dataSource="dataSource"
        :pagination="ipagination"
        :loading="loading"
        :rowSelection="{ selectedRowKeys: selectedRowKeys, onChange: onSelectChange, type: 'radio' }"
        :customRow="clickThenSelect"
        @change="handleTableChange"
      >
<span slot="num" slot-scope="text">
          <j-ellipsis :value="text" :length="15" />
        </span>
        <template
          slot="htmlSlot"
          slot-scope="text"
        >
          <div v-html="text"></div>
        </template>
        <template
          slot="imgSlot"
          slot-scope="text,record"
        >
          <span
            v-if="!text"
            style="font-size: 12px;font-style: italic;"
          >无图片</span>
          <img
            v-else
            :src="getImgView(text)"
            :preview="record.id"
            height="25px"
            alt=""
            style="max-width:80px;font-size: 12px;font-style: italic;"
          />
        </template>
        <template
          slot="fileSlot"
          slot-scope="text"
        >
          <span
            v-if="!text"
            style="font-size: 12px;font-style: italic;"
          >无文件</span>
          <a-button
            v-else
            :ghost="true"
            type="primary"
            icon="download"
            size="small"
            @click="downloadFile(text)"
          >
            下载
          </a-button>
        </template>

        <span
          slot="action"
          slot-scope="text, record"
        >
          <a-popconfirm
            v-if="record.auditStatus == 'notSubmitted' || record.auditStatus == 'Rejected'"
            title="确认提交吗?"
            @confirm="() =>handleCommit(record,'commit')"
          >
            <a>提交</a>
          </a-popconfirm>
          <a-popconfirm
            v-if="record.auditStatus == 'pendingApproval'"
            title="确认撤回吗?"
            @confirm="() =>handleCommit(record,'back')"
          >
            <a>撤回</a>
          </a-popconfirm>

          <a-divider
            v-if="record.auditStatus == 'notSubmitted' || record.auditStatus == 'pendingApproval' || record.auditStatus == 'Rejected'"
            type="vertical"
          />
          <a
            v-if="record.auditStatus == 'notSubmitted' || record.auditStatus == 'Rejected'"
            @click="handleEdit(record)"
          >编辑</a>
          <a
            v-if="record.auditStatus == 'pendingApproval'"
            @click="handleApprove(record)"
          >审批</a>
          <a-divider
            v-if="record.auditStatus == 'notSubmitted' || record.auditStatus == 'pendingApproval' || record.auditStatus == 'Rejected'"
            type="vertical"
          />
          <a-dropdown>
            <a class="ant-dropdown-link">更多 <a-icon type="down" /></a>
            <a-menu slot="overlay">
              <a-menu-item>
                <a @click="handleDetail(record)">详情</a>
              </a-menu-item>
              <a-menu-item v-if="record.auditStatus == 'notSubmitted'">
                <a-popconfirm
                  v-if="record.auditStatus == 'notSubmitted'"
                  title="确定删除吗?"
                  @confirm="() => handleDelete(record.id)"
                >
                  <a>删除</a>
                </a-popconfirm>
              </a-menu-item>
            </a-menu>
          </a-dropdown>
        </span>

        <!-- <span slot="action" slot-scope="text, record">
          <a @click="handleEdit(record)">编辑</a>

          <a-divider type="vertical" />
          <a-dropdown>
            <a class="ant-dropdown-link">更多 <a-icon type="down" /></a>
            <a-menu slot="overlay">
              <a-menu-item>
                <a @click="handleDetail(record)">详情</a>
              </a-menu-item>
              <a-menu-item>
                <a-popconfirm title="确定删除吗?" @confirm="() => handleDelete(record.id)">
                  <a>删除</a>
                </a-popconfirm>
              </a-menu-item>
            </a-menu>
          </a-dropdown>
        </span> -->

      </a-table>
    </div>

    <a-tabs defaultActiveKey="1">
      <a-tab-pane
        tab="设备启封明细"
        key="1"
      >
        <EquipmentUnsealDetailList :mainId="equipmentUnsealDetailMainId" />
      </a-tab-pane>
    </a-tabs>

    <equipmentUnseal-modal
      ref="modalForm"
      @ok="modalFormOk"
    ></equipmentUnseal-modal>
    <approvel-modal
      ref="approvalModalForm"
      @ok='approvalModalFormOk'
      @cancel='approvalModalFormOk'
    ></approvel-modal>
  </a-card>
</template>

<script>

import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import EquipmentUnsealModal from './modules/equipmentUnseal/EquipmentUnsealModal'
import { getAction, deleteAction, postAction } from '@/api/manage'
import EquipmentUnsealDetailList from './modules/equipmentUnseal/EquipmentUnsealDetailList'
import { initDictOptions, filterMultiDictText } from '@/components/dict/JDictSelectUtil'
import '@/assets/less/TableExpand.less'
import ApprovelModal from './modules/equipmentSeal/ApprovelModal'

export default {
  name: 'EquipmentUnsealList',
  mixins: [JeecgListMixin],
  components: {
    EquipmentUnsealModal,
    EquipmentUnsealDetailList,
    ApprovelModal
  },
  data() {
    return {
      description: '设备启封管理页面',
      // 表头
      columns: [
        {
          title: '#',
          dataIndex: '',
          key: 'rowIndex',
          width: 60,
          align: 'center',
          customRender: function (t, r, index) {
            return parseInt(index) + 1
          }
        },
        {
          title: '审批状态',
          align: 'center',
          dataIndex: 'auditStatus_dictText'
        },
        {
          title: '单据号',
          align: 'center',
          sorter: true,
          dataIndex: 'num',
          scopedSlots: { customRender: 'num' },
          width: 100,
          ellipsis: true
        },
        {
          title: '创建人',
          align: 'center',
          dataIndex: 'createBy'
        },
        {
          title: '创建时间',
          align: 'center',
          dataIndex: 'createTime',
          customRender: function (text) {
            return !text ? '' : (text.length > 10 ? text.substr(0, 10) : text)
          }
        },
        {
          title: '修改人',
          align: 'center',
          dataIndex: 'updateBy'
        },
        {
          title: '修改时间',
          align: 'center',
          dataIndex: 'updateTime',
          customRender: function (text) {
            return !text ? '' : (text.length > 10 ? text.substr(0, 10) : text)
          }
        },
        {
          title: '备注',
          align: 'center',
          dataIndex: 'remark'
        },
        {
          title: '操作',
          dataIndex: 'action',
          align: 'center',
          fixed: 'right',
          width: 147,
          scopedSlots: { customRender: 'action' }
        }
      ],
      url: {
        list: '/eam/equipmentUnseal/list',
        approve: '/eam/equipmentUnseal/approve',
        delete: '/eam/equipmentUnseal/delete',
        deleteBatch: '/eam/equipmentUnseal/deleteBatch',
        exportXlsUrl: '/eam/equipmentUnseal/exportXls',
        importExcelUrl: 'eam/equipmentUnseal/importExcel',
        submit: 'eam/equipmentUnseal/submit',
        revocation: 'eam/equipmentUnseal/revocation'
      },
      dictOptions: {
        auditStatus: []
      },
      /* 分页参数 */
      ipagination: {
        current: 1,
        pageSize: 5,
        pageSizeOptions: ['5', '10', '50'],
        showTotal: (total, range) => {
          return range[0] + '-' + range[1] + ' 共' + total + '条'
        },
        showQuickJumper: true,
        showSizeChanger: true,
        total: 0
      },
      selectedMainId: '',
      equipmentUnsealDetailMainId: '',
      // 默认变动方式 封存-seal，启封-unseal,报废-scrap，处置-disposal
      changeMethod: 'unseal'
    }
  },
  created() {

  },
  computed: {
    importExcelUrl: function () {
      return `${window._CONFIG['domianURL']}/${this.url.importExcelUrl}`
    }
  },
  methods: {
    initDictConfig() {
    },
    clickThenSelect(record) {
      return {
        on: {
          click: () => {
            this.onSelectChange(record.id.split(','), [record])
          }
        }
      }
    },
    onClearSelected() {
      this.selectedRowKeys = []
      this.selectionRows = []
      this.selectedMainId = ''
    },
    onSelectChange(selectedRowKeys, selectionRows) {
      this.selectedMainId = selectedRowKeys[0]
      this.selectedRowKeys = selectedRowKeys
      this.selectionRows = selectionRows
      this.equipmentUnsealDetailMainId = selectionRows[0]['id']
    },
    async loadData(arg) {
      if (!this.url.list) {
        this.$message.error('请设置url.list属性!')
        return
      }
      //加载数据 若传入参数1则加载第一页的内容
      if (arg === 1) {
        this.ipagination.current = 1
      }
      this.onClearSelected()
      var params = this.getQueryParams()//查询条件
      this.loading = true
      await getAction(this.url.list, params).then((res) => {
        if (res.success) {
          this.dataSource = res.result.records
          this.ipagination.total = res.result.total
        }
        if (res.code === 510) {
          this.$message.warning(res.message)
        }
        this.loading = false
      })
      this.equipmentUnsealDetailMainId = ""
    },
    handleCommit(record, type) {
      let url
      type == 'commit' ? record.auditStatus = 'pendingApproval' : record.auditStatus = 'notSubmitted'
      type == 'commit' ? url = this.url.submit : url = this.url.revocation
      postAction(url, record).then(res => {
        if (res.success) {
          if (type === 'commit') {
            this.$message.success("提交成功！");
          } else {
            this.$message.success("撤回成功！");
          }

          this.loadData(1);
        } else {
          this.$message.warning(res.message);
        }
      })
    },
    handleApprove: function (record) {
      let approve
      approve = this.url.approve
      this.$refs.approvalModalForm.showModals(record, approve, 'Approved', 'Rejected')
      this.$refs.approvalModalForm.title = '审批'
      this.$refs.approvalModalForm.disableSubmit = false

    },
    approvalModalFormOk() {
      // 通过/驳回时，重载列表
      this.loadData()
      //清空列表选中
      this.onClearSelected()
    },

    searchReset() {
      this.queryParam = {
        changeMethod: this.changeMethod
      }
      this.loadData(1)
    },
    // 模态框确认
    async modalFormOk() {
      this.queryParam = {
        changeMethod: this.changeMethod
      }
      // 新增/修改 成功时，重载列表
      await this.loadData(1)
      // 选中列表新增项
      this.selectedRowKeys = [this.dataSource[0].id]
      this.selectionRows = [this.dataSource[0]]
      this.selectedMainId = this.dataSource[0].id
      this.equipmentUnsealDetailMainId = this.dataSource[0].id
    },
    handleDelete(id) {
      this.queryParam = {
        changeMethod: this.changeMethod
      }
      if (!this.url.delete) {
        this.$message.error('请设置url.delete属性!')
        return
      }
      deleteAction(this.url.delete, { id: id }).then(res => {
        if (res.success) {
          //重新计算分页问题
          this.reCalculatePage(1)
          this.$message.success(res.message)
          this.loadData()
        } else {
          this.$message.warning(res.message)
        }
      })
    },
  }
}
</script>
<style scoped>
@import '~@assets/less/common.less';
</style>